<?php
// 쪽글에 짧은 주소 넣기 1.0.4
// 만든이 : 팥알 (http://pat.im)

if(isset($_GET['linkURL'])) {
	$SNS_linkURL = $_GET['linkURL'];
	$longURL = $_GET['longURL'];
	$shortURL_domain = $_GET['shortURL_domain'];
} else {
	$SNS_linkURL = $_POST['linkURL'];
	$longURL = $_POST['longURL'];
	$shortURL_domain = $_POST['shortURL_domain'];
}

$shortURL = get_shortURL($longURL, $shortURL_domain);

if(preg_match('/^(http:\/\/'.$shortURL_domain.')/', $shortURL))
	$SNS_linkURL = str_replace(urlencode($longURL), urlencode($shortURL), $SNS_linkURL);

echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
	<head>
	<title></title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	</head>
	<body onload="window.location = \''.$SNS_linkURL.'\'">
	</body>
</html>';

function get_shortURL($longURL, $shortURL_domain) {
	switch($shortURL_domain) {
		case 'bit.ly' :
		case 'j.mp' :
		  $login = 'pluginuser';
			$api_key = 'R_1e8b5c3c3298d04077a30d73ae348f17';
			$curlopt_url = 'http://api.'.$shortURL_domain.'/v3/shorten?login='.$login.'&apiKey='.$api_key.'&uri='.$longURL.'&format=txt';
			break;
		case 'is.gd' :
			$curlopt_url = 'http://is.gd/api.php?longurl='.$longURL;
			break;
		case 'v.gd' :
			$curlopt_url = 'http://v.gd/create.php?format=simple&url='.$longURL;
			break;
		case 'to.ly' :
			$curlopt_url = 'http://to.ly/api.php?longurl='.$longURL;
			break;
		case 'dok.do' :
			$curlopt_url = 'http://dok.do/api/shorten?format=json&longUrl='.$longURL;
			break;
		case 'goo.gl' :
			$api_key = 'AIzaSyCD5tyP0I7VxxYEEdXvCj99i0vb_xdYy8I';
			$curlopt_url = 'https://www.googleapis.com/urlshortener/v1/url?key='.$api_key;
			break;
		case 'durl.me' :
			$curlopt_url = 'http://durl.me/api/Create.do?type=json&longurl='.$longURL;
			break;			
		case 'tinyurl' :
			$curlopt_url = 'http://tinyurl.com/api-create.php?url='.$longURL;
			break;
	}

	$ch = curl_init();
  //$timeout = 10;
  
	curl_setopt($ch, CURLOPT_URL, $curlopt_url);
	curl_setopt($ch, CURLOPT_HEADER, false);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	//curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);

	if( preg_match('/^(goo\.gl|durl\.me|dok\.do|)$/',$shortURL_domain) ) {
	  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_POST, true); 
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json')); 
		$jsonArray = array('longUrl' => $longURL); 
		curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($jsonArray)); 
	  $shortURL = curl_exec($ch);
	  curl_close($ch);
 		$result_array = json_decode($shortURL, true); 

		if($result_array['shortUrl']) return $result_array['shortUrl'];		// durl.me
 		else if($result_array['id']) return $result_array['id'];	// goo.gl
 		else if($result_array['data']['short_url']) return $result_array['data']['short_url'];	// dok.do
 		else return false;
  }

	$shortURL = curl_exec($ch);
	curl_close($ch);
	
	if( ($shortURL_domain == 'j.mp' || $shortURL_domain  == 'bit.ly') && bin2hex(substr($shortURL, -1, 1)) == '0a')
		$shortURL = substr($shortURL, 0, strlen($shortURL)-1);		// bit.ly(j.mp) 주소 끝의 줄바꿈 문자(LF, 0x0A)를 없앰

	return $shortURL;
}

?>